//+------------------------------------------------------------------+
//|                                                    BDMhelper.mq4 |
//|                                           Alguasta Software 2015 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Alguasta Software 2015"
#property link      ""
#property version   "1.01"
#property strict
#property indicator_chart_window

#import "user32.dll"
    void keybd_event(int bVk, int bScan, int dwFlags,int dwExtraInfo);
#import

#import "user32.dll"
int GetForegroundWindow();
int FindWindowExW(int,int,string,string);
int GetWindowRect(int,int &arr[]);
int GetClientRect(int,int &arr[]);
int SetWindowLongW(int,int,int);
int SetWindowLongPtr(int,int,int);
int GetWindowLongW(int,int);
int GetSystemMenu(int,bool);
int InsertMenuW(int,int,int,int,string);
int SetWindowPos(int,int,int,int,int,int,int);
int GetParent(int);
int GetWindowTextW(int,short &arr[],int);
int ShowWindow(int,int);
int GetClassNameW(int,short &arr[],int);
int GetDlgCtrlID(int);
int GetDlgItem(int,int);
bool IsZoomed(int);
bool InvalidateRect(int,int &arr[],bool);
bool AnimateWindow(int, int, int);
int GetWindowRect(int,int &arr[]);
bool MoveWindow(int,int,int,int,int,bool);
bool BringWindowToTop(int);
double GetLastError(void);
#import

#define GWL_STYLE         -16 
#define WS_SIZEBOX        0x00040000
#define WS_MINIMIZEBOX    0x00020000
#define WS_MAXIMIZEBOX    0x00010000
#define WS_CAPTION        0x00C00000
#define WS_THICKFRAME     0x00040000
#define WS_SYSMENU        0x00080000
#define WS_MAXIMIZE       0x01000000
#define WS_MINIMIZE       0x20000000
#define WS_DLGFRAME       0x00400000
#define WS_POPUP          0x80000000
#define WS_CHILD          0x40000000
#define WS_THINFRAME      0x00100000
#define MF_STRING         0x00000000
#define MF_BYPOSITION     0x00000400
#define SW_MAXIMIZE       0x0003
#define SC_SIZE           0xF000
#define SC_MAXIMIZE       0xF030
#define SC_MINIMIZE       0xF020
#define SC_RESTORE        0xF120
#define SWP_NOSIZE        0x0001
#define SWP_NOMOVE        0x0002
#define SWP_NOZORDER      0x0004
#define SWP_NOREDRAW      0x0008
#define SWP_NOACTIVATE    0x0010
#define SWP_FRAMECHANGED  0x0020

int originalwidth;
int originalheight;
int originalx;
int originaly;
int originaltf;
bool chartlarge = false;
int windowposinfo[4];
int mainposinfo[4];

int wndh,wndhp;
int xpos,ypos,xsize,ysize;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   ObjectCreate(0,"chsize",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"chsize",OBJPROP_XSIZE,50);
   ObjectSetInteger(0,"chsize",OBJPROP_YSIZE,20);
   ObjectSetInteger(0,"chsize",OBJPROP_BGCOLOR,clrGray);
   ObjectSetInteger(0,"chsize",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
   ObjectSetInteger(0,"chsize",OBJPROP_YDISTANCE,30);
   ObjectSetInteger(0,"chsize",OBJPROP_XDISTANCE,1);
   ObjectSetString(0,"chsize",OBJPROP_FONT,"Arial");
   ObjectSetInteger(0,"chsize",OBJPROP_FONTSIZE,8);
   ObjectSetInteger(0,"chsize",OBJPROP_COLOR,clrWhite);
   ObjectSetString(0,"chsize",OBJPROP_TEXT,"Size");
   ObjectSetInteger(0,"chsize",OBJPROP_BACK,0);
   ObjectSetInteger(0,"chsize",OBJPROP_STATE,0);
   ObjectSetInteger(0,"chsize",OBJPROP_SELECTABLE,0);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {

    if(id==CHARTEVENT_OBJECT_CLICK) {

      string clickedChartObject=ObjectGetString(0,sparam,OBJPROP_TEXT);
      string clickedObjectName = sparam;

      if (clickedObjectName == "chsize") {

         ObjectSetInteger(0,"chsize",OBJPROP_STATE,0);

         wndh = WindowHandle(Symbol(),Period());
         if (wndh == -1)
            return;

         wndhp = WindowHandle("EURSEK",PERIOD_M1);
         if (wndhp == -1)
            return;

         if (chartlarge == false) {
            chartlarge = true;
            GetWindowRect(wndh,windowposinfo);
            GetWindowRect(wndhp,mainposinfo);
            originalx = windowposinfo[0] - mainposinfo[0];
            originaly = windowposinfo[1] - mainposinfo[1];
            originalwidth = windowposinfo[2]-windowposinfo[0];
            originalheight = windowposinfo[3] - windowposinfo[1];
            xpos = 50;
            ypos = 140;
            xsize = 1400;
            ysize = 600;
            resizeWindow(Symbol(),Period(),xpos,ypos,xsize,ysize);
         } else {
            chartlarge = false;
            xpos = originalx;
            ypos = originaly;
            xsize = originalwidth;
            ysize = originalheight;
            resizeWindow(Symbol(),Period(),xpos,ypos,xsize,ysize);
         }
         return;
      }
   }
   
  }
    #define AW_HOR_POSITIVE            0x00000001
    #define AW_HOR_NEGATIVE            0x00000002
    #define AW_VER_POSITIVE            0x00000004
    #define AW_VER_NEGATIVE            0x00000008
    #define AW_CENTER                  0x00000010
    #define AW_HIDE                    0x00010000
    #define AW_ACTIVATE                0x00020000
    #define AW_SLIDE                   0x00040000
    #define AW_BLEND                   0x00080000

 void resizeWindow(string symbol, int period, int xpos, int ypos, int xsize, int ysize) {


   wndh = WindowHandle(symbol,period);
   if (wndh == -1)
      return;

   wndhp = GetParent(wndh);
   if (wndhp == -1)
      return;

   AnimateWindow(wndhp,500,AW_HIDE|AW_CENTER);
   MoveWindow(wndhp,xpos,ypos,xsize,ysize,false);
   BringWindowToTop(wndhp);
   ShowWindow(wndhp,5);
   
}  
